'
' Temperature Converter Sample C# language version
' 
' Copyright 2002~2003 Marco Savegnago msave@tin.it
'

Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports System.Text

Namespace TempConverter

    Public Class TempConverterForm
        Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Windows Form Designer.
            InitializeComponent()

            'Add any initialization after the InitializeComponent() call

        End Sub

        'Form overrides dispose to clean up the component list.
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If disposing Then
                If Not (components Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)
        End Sub

        'Required by the Windows Form Designer
        Private components As System.ComponentModel.IContainer

        'NOTE: The following procedure is required by the Windows Form Designer
        'It can be modified using the Windows Form Designer.  
        'Do not modify it using the code editor.
        Friend WithEvents labelCelsius As System.Windows.Forms.Label
        Friend WithEvents editCelsius As System.Windows.Forms.TextBox
        Friend WithEvents labelFahrenheight As System.Windows.Forms.Label
        Friend WithEvents editFahrenheight As System.Windows.Forms.TextBox
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            Me.labelCelsius = New System.Windows.Forms.Label
            Me.editCelsius = New System.Windows.Forms.TextBox
            Me.labelFahrenheight = New System.Windows.Forms.Label
            Me.editFahrenheight = New System.Windows.Forms.TextBox
            Me.SuspendLayout()
            '
            'labelCelsius
            '
            Me.labelCelsius.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            Me.labelCelsius.Location = New System.Drawing.Point(8, 16)
            Me.labelCelsius.Name = "labelCelsius"
            Me.labelCelsius.Size = New System.Drawing.Size(48, 16)
            Me.labelCelsius.TabIndex = 5
            Me.labelCelsius.Text = "Celsius"
            '
            'editCelsius
            '
            Me.editCelsius.Location = New System.Drawing.Point(9, 40)
            Me.editCelsius.Name = "editCelsius"
            Me.editCelsius.Size = New System.Drawing.Size(207, 20)
            Me.editCelsius.TabIndex = 6
            Me.editCelsius.Text = ""
            '
            'labelFahrenheight
            '
            Me.labelFahrenheight.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
            Me.labelFahrenheight.Location = New System.Drawing.Point(8, 72)
            Me.labelFahrenheight.Name = "labelFahrenheight"
            Me.labelFahrenheight.Size = New System.Drawing.Size(80, 16)
            Me.labelFahrenheight.TabIndex = 7
            Me.labelFahrenheight.Text = "Fahrenheight"
            '
            'editFahrenheight
            '
            Me.editFahrenheight.Location = New System.Drawing.Point(9, 96)
            Me.editFahrenheight.Name = "editFahrenheight"
            Me.editFahrenheight.Size = New System.Drawing.Size(208, 20)
            Me.editFahrenheight.TabIndex = 8
            Me.editFahrenheight.Text = ""
            '
            'TempConverterForm
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(226, 128)
            Me.Controls.Add(Me.editFahrenheight)
            Me.Controls.Add(Me.labelFahrenheight)
            Me.Controls.Add(Me.editCelsius)
            Me.Controls.Add(Me.labelCelsius)
            Me.Font = New System.Drawing.Font("Arial", 8.25!)
            Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
            Me.MaximizeBox = False
            Me.MinimizeBox = False
            Me.Name = "TempConverterForm"
            Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
            Me.Text = ".NET Temperature Converter in VB"
            Me.ResumeLayout(False)

        End Sub

#End Region

        Private Sub editCelsius_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles editCelsius.TextChanged

            'Clear string in another textbox if there are non here

            If editCelsius.Text.Length <= 0 Or (editCelsius.Text.Length = 1 And editCelsius.Text.Equals("-")) Then
                editFahrenheight.Text = ""
                'Textbox is not empty
            Else
                'If another control is simulating the text change,
                'then do not proceed with the text conversion for this control
                If editCelsius.Focused = False Then
                    Return
                End If

                'To hold our converted single precision float value

                Dim fDegree As Single

                fDegree = 0

                Try
                    ' Convert text string to unsigned integer
                    fDegree = System.Convert.ToSingle(editCelsius.Text)
                    fDegree = (fDegree * 9 / 5) + 32

                Catch exception As System.OverflowException
                    ' Show overflow message and return
                    editFahrenheight.Text = "Overflow"
                    Return

                Catch exception As System.FormatException
                    editFahrenheight.Text = "Format"
                    Return

                End Try

                ' Format unsigned integer value to hex and show in another textbox
                editFahrenheight.Text = fDegree.ToString()
            End If

        End Sub

        Private Sub editFahrenheight_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles editFahrenheight.TextChanged
            'Clear string in another textbox if there are non here
            If editFahrenheight.Text.Length <= 0 Or (editFahrenheight.Text.Length = 1 And editFahrenheight.Text.Equals("-")) Then
                editCelsius.Text = ""

                'Textbox is not empty
            Else
                ' If another control is simulating the text change,
                ' then do not proceed with the text conversion for this control
                If editFahrenheight.Focused = False Then
                    Return
                End If

                ' To hold our converted single precision float value
                Dim fDegree As Single

                fDegree = 0

                Try
                    ' Convert hex string to unsigned integer
                    fDegree = System.Convert.ToSingle(editFahrenheight.Text)
                    fDegree = (fDegree - 32) * 5 / 9


                Catch exception As System.OverflowException
                    'Show overflow message and return
                    editCelsius.Text = "Overflow"
                    Return

                Catch exception As System.FormatException
                    editCelsius.Text = "Format"
                    Return

                    'Format it and show as a string
                    editCelsius.Text = fDegree.ToString()
                End Try
            End If

        End Sub

        Private Sub check_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs)
            ' Process only digits and backspace

            e.Handled = True

            If Char.IsDigit(e.KeyChar) Then
                e.Handled = False
            End If

            Select Case e.KeyChar
                Case "-"c
                    e.Handled = False
                Case "."c
                    e.Handled = False
                Case Chr(8)
                    e.Handled = False

            End Select

        End Sub

        Private Sub editCelsius_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles editCelsius.KeyPress
            Call check_KeyPress(sender, e)
        End Sub

        Private Sub editFahrenheight_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles editFahrenheight.KeyPress
            Call check_KeyPress(sender, e)
        End Sub

        Private Sub editCelsius_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles editCelsius.Enter
            ' Check if we have an "Overflow" message here, remove it
            ' when we have a focus cos we are not and should not be
            ' handling alphabets other than 'a' to 'f' here.
            If editCelsius.Text = "Overflow" Then
                editCelsius.Text = ""
            End If

            If editCelsius.Text = "Format" Then
                editCelsius.Text = ""
            End If
        End Sub

        Private Sub editFahrenheight_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles editFahrenheight.Enter
            ' Check if we have an "Overflow" message here, remove it
            ' when we have a focus cos we are not and should not be
            ' handling alphabets other than 'a' to 'f' here.
            If editFahrenheight.Text = "Overflow" Then
                editFahrenheight.Text = ""
            End If

            If editFahrenheight.Text = "Format" Then
                editFahrenheight.Text = ""
            End If

        End Sub
    End Class

End Namespace